; C library routine to allow mixed use of standard c library and
; syslib (and other extensions which use the Dynamic Link Library Manager)
; written by Joachim Van der Auwera for PROGS
; (c) 1995 PROGS, Professional & Graphical Software
; started 17 April 1995
;
; modified extensively by wl starting on   1996 Aug 31 22:31:22
; v. 1.01   1996 Sep 10 09:44:46
;

	section text
	include asm_aid_mac
	xref	use_thg
	xref	linkedDLL

;
_LinkDLL	xsub
	regsave d0-d7/a0-a5

	move.l	#'ASM ',d2	; extension
	lea	DLLManager(pc),a0	; thing to use
	jsr	use_thg		; use it
	bne.s	kill

	lea	linkage(pc),a4	; information to do it all
	move.l	a4,-(sp)		; linkage is parameter
	jsr	$18(a1)		; start program

	; release parameter
	addq.l	#4,sp
				; ... handle all possible errors ...
				; ... hey, what can we do ?? ...
				; ... oh, quite a lot!

	tst.l	d0		; linkage ok?
	bne.s	kill		; no! ->...
	lea	linkedDLL(pc),A0	; show that linkage was done OK...
	move.b	#-1,(A0)		; ...by setting this
	tst.l	d0		; return w or w/o error
kill	subend

; thg_name    dc.w	    5,'THING'
DLLManager  dc.w	  11,'DLL Manager'

	xref the_beginning
linkage dc.l	linkage-the_beginning
	dc.l	0
	dc.l	bssbase-the_beginning
;
; I don't need this, but apparently the linker does !!
; use this to force linking of syslib
	section data
	xref	_InitSysLib
	dc.l	_InitSysLib-*
;
	section udata
bssbase
;
	end
