; this is the PWquery keyword for the Prowess Sbasic interface
; v. 1.01       1996 May 19 17:02:26
;  copyright (c) W. Lenerz 1996



*************************************************************************
*
* This is the PWquery keyword
*
* syntax: result=PWquery(object, what)
*
* where: object is the object to query
*        what is the query tag
*        result is the result that will be returned
***************************************************************************



         section  ioop

         xdef     ioop

         include  asm_includes_asm
         xref     _ioopenpath
         xref     gmem              ; get mem in my format (prowess_asm_gmem)
         xref     get_all2          ; get params & push onto stack (prowess_asm_getparams)
         xref     gu_rchp           ; release common heap mem (gu_rechp)
         xref     rt_fp             ; return fp to basic (lib_returnparams)
         xref     err_out           ; reset stack, rel mem & rts with error (prowess_asm_pwactivate)
         xref     e_o               ; rel mem & rts with error (prowess_asm_pwactivate)
         xref     rt_str

ioop     BSR      gmem              ;
         MOVE.L   #0,-(A4)          ; NULL
         MOVE.L   A0,-(A4)          ; pointer for return param
         ADDQ.L   #4,A0             ; pointer after this parameter
         BSR      get_all2          ; push parameters onto stack
         BNE      e_o
         MOVE.L   A4,A7             ; new stack pointer
         BSR      _ioopenpath          ; do it
         TST.L    D0                ; did call go ok?
         BNE      err_out           ; no->...
         reset_stk                  ; get my stack back
         MOVE.L   4(A0),D2          ; return parameter
         BSR      gu_rchp           ; release mem


         end
